package rozdzial25c;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.stage.Stage;

public class Listing25_55 extends Application {

    public static void main(String[] args) {
        Application.launch(args);
    }

    @Override
    public void start(Stage stage) {
        try {
            Group root = new Group();
            Canvas cv = new Canvas(500, 500);
            GraphicsContext gc = cv.getGraphicsContext2D();
            //-
            var x = 250;
            var y = 250;
            var radius = 75;
            //-
            gc.setFill(Color.GREEN);
            gc.beginPath();
            gc.arc(x - 100, y - 30, radius, radius, 0, 360);
            gc.fill();
            //
            gc.beginPath();
            gc.arc(x, y, radius, radius,0, 360);
            gc.clip();
            //
            gc.setFill(Color.ORANGE);
            gc.setFont(Font.font("sans-serif", 70));
            gc.beginPath();
            gc.fillText("Urszula", 100, 250);
            //
            gc.setLineWidth(3);
            gc.beginPath();
            gc.arc(x, y, radius, radius, 0, 360);
            gc.stroke();
            gc.setStroke(Color.BLUE);
            gc.strokeLine(20, 20, 480, 480);
            //-
            root.getChildren().add(cv);
            Scene scene = new Scene(root);
            stage.setScene(scene);
            stage.setTitle("Atrybut ogólny 'clip'");
            stage.setOnCloseRequest(e -> Platform.exit());
            stage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
